/**
 * Created by FreetimeCoder 2012
 * www.freetimestudio.de
 * Use as you wish, credits are appreciated ;)
 */
class SeqAct_QTEInputSwap extends SequenceAction;

//Whether Button A or B is right (A beign first)
var bool bFirstInputIsRight;

/**
 * Sequence was activated by one of the input links
 */
event Activated()
{
	//If started, reset
	if(InputLinks[0].bHasImpulse)
	{
		bFirstInputIsRight = true;
	}
	//Button A was activated
	else if(InputLinks[1].bHasImpulse)
	{
		CheckInput(true,false);
	}
	//Button B was activated
	else if(InputLinks[2].bHasImpulse)
	{
		CheckInput(false,true);
	}
}

/**
 * Check input and activate outputs accordingly
 */
function CheckInput(bool _bBtnA, bool _bBtnB)
{
	//Correct button was pressed
	if((_bBtnA && bFirstInputIsRight) || (_bBtnB && !bFirstInputIsRight))
	{
		//Switch needed button
		bFirstInputIsRight = !bFirstInputIsRight;
		//Success
		ActivateOutputLink(0);
	}
	//Wrong button was pressed
	else
	{
		//Failure
		ActivateOutputLink(1);
	}
}

DefaultProperties
{
	ObjName = "QTE Toggle Input"
	ObjCategory = "Quick Time Events"

	InputLinks.Empty()
	InputLinks(0)=(LinkDesc="Reset");
	InputLinks(1)=(LinkDesc="Button A");
	InputLinks(2)=(LinkDesc="Button B");

	OutputLinks.Empty()
	OutputLinks(0)=(LinkDesc="Success");
	OutputLinks(1)=(LinkDesc="Failure");
	
	bAutoActivateOutputLinks = false
	bFirstInputIsRight = true
}
